<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 150 post lists </title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
</head>

<body>
  <div class="container-fluid">
    <div class="text-center my-4">
      <h3 > <span class="text-warning">Danh sách</span> bình luận của bài viết</h3>
      
    </div>
    <div class="row form-group">
      <div class="col-sm-2">
        <label class="form-control border border-0 text-dark"> Điền Post ID: </label>
      </div>
      <div class="col-sm-6">
        <input type="text" class="form-control border border-dark" id="inp-user-id" placeholder="Gợi ý post id đúng: 3">
      </div>
      <div class="col-sm-4">
        <button class="btn btn-success form-control" id="btn-get-user-posts"> Lấy danh sách bình luận của bài viết </button>
      </div>
    </div>
    <table class="table table-bordered table-striped table-hover" id="tbl-user-posts">
      <thead>
        <tr>
          <th>ID</th>
          <th>Post ID</th>
          <th>Email</th>
          <th>Name</th>
          <th>Body</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
        <tr>
          <td>11</td>
          <td>11</td>
          <td>ádsfdg_Goodwin@timmothy.net</td>
          <td>asdsfgf asdsfd  odit aut ullam nostrum tenetur	</td>
          <td>nihil ut voluptates blanditiis autem odio dicta rerum quisquam saepe et est sunt </td>
          <td>Action (thao tác)</td>
        </tr>
        <tr>
          <td>11</td>
          <td>11</td>
          <td>sadsgfg_Goodwin@timm.com</td>
          <td>basvhav asasvbvbsvb t aut ullam nostrum tenetur	</td>
          <td>nihil ut voluptates blanditiis autem odio dicta rerum quisquam saepe et est sunt </td>
          <td>Action (thao tác)</td>
        </tr>
      </tbody>
    </table>
  </div>

  <script>
    "use strict";

    /*** REGION 1 - Global variables - Vùng khai báo hằng số, tham số TOÀN CỤC */
    const gBASE_URL = "https://jsonplaceholder.typicode.com";
  
    /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
    $(document).ready(function () {
      //gán event handler cho nút 
      $("#btn-get-user-posts").on("click", function () {
        onBtnGetUserPostsClick();
      });
    });

    /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
    // hàm xử lý sự kiện lấy post của người dùng (4 bước xử lý)
    function onBtnGetUserPostsClick() {
      //1.đọc dữ liệu
      var vPostId = {
        postId: 0
      };
      readDataPostIdObject(vPostId);
      //2.kiểm tra
      var vKetQuaKiemTra = validatePostIdObject(vPostId);
      if (vKetQuaKiemTra) {
        //3. gọi server 

        $.ajax({
          url: gBASE_URL + "/posts/" + vPostId.postId + "/comments/",
          type: 'GET',
          dataType: 'json', // added data type
          success: function (responseObject) {
            console.log(JSON.stringify(responseObject));  //response text
            //4 xử lý hiện thị
            loadTableUserPostData(responseObject)  // responseObject là array các posts
          },
          error: function (ajaxContext) {
            alert(ajaxContext.responseText)
          }
        });
      }
    }

    //hàm xử lý sự kiện click button detail
    function onDetailButtonClick(paramSuKienClick) {
      console.log("%cDetail button click. Sự kiện Click là: ....", "color:orange");
      var vButtonBiAn = paramSuKienClick.currentTarget;
      const vFORM_TO_OPEN = "task.Bs150PostDetail.html"  //đây là form sẽ mở
      var vUrlToOpenPage = vFORM_TO_OPEN + "?"
        + "id=" + $(vButtonBiAn).data("id");
      window.location.href = vUrlToOpenPage;
    }

    /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/


    //hàm load dữ liệu lên table
    function loadTableUserPostData(paramPosts) {
      //xóa dữ liệu của bảng
      $("#tbl-user-posts tbody").html("");

      //đổ dữ liệu
      for (var bI = 0; bI < paramPosts.length; bI++) {
        //tạo row
        var bNewRow = $("<tr>").appendTo($("#tbl-user-posts  tbody"));
        // tao cell  
        $("<td>").html(paramPosts[bI].id)
          .appendTo(bNewRow);  //append vào hàng mới

        $("<td>").html(paramPosts[bI].postId)
          .appendTo(bNewRow);

        $("<td>").html(paramPosts[bI].email)
          .appendTo(bNewRow);

        $("<td>").html(paramPosts[bI].name)
          .appendTo(bNewRow);

        $("<td>").html(paramPosts[bI].body)
          .appendTo(bNewRow);

        // xử lý cột action (có nút)
        var bColAction = $("<td>").addClass("btn-group").appendTo(bNewRow);//cột action
        /* nút chi tiết */
        var bDetailButton = $("<button>", { html: "Chi tiết" })
          .addClass('btn btn-warning')
          .data("id", paramPosts[bI].id)
          .appendTo(bColAction);
        // thêm sự kiện cho nút này
        bDetailButton.click(onDetailButtonClick);
      }
    }
    // read data
    function readDataPostIdObject(paramUserIdObject) {
      paramUserIdObject.postId = parseInt($("#inp-user-id").val().trim());
    }

    // validate data
    function validatePostIdObject(paramUserIdObject) {
      if (isNaN(paramUserIdObject.postId)) {
        alert("Dữ liệu userId phải nhập vào là số !");
        return false;
      }

      return true;
    }
  </script>
</body>

</html>